// ignore_for_file: camel_case_types

import 'dart:isolate';

import 'package:universal_io/io.dart';

import 'vm.dart';

class dart {
  static Vm get vm {
    return Vm();
  }

  static ReceivePort receivePortCurrent() {
    return ReceivePort(Isolate.current.debugName ?? "main");
  }

  static Isolate isolateCurrent({
    SendPort? controlPort,
  }) {
    if (controlPort != null) {
      return Isolate(
        controlPort,
        pauseCapability: Isolate.current.pauseCapability,
        terminateCapability: Isolate.current.terminateCapability,
      );
    }
    return Isolate.current;
  }

  static bool get isRelease => const bool.fromEnvironment('dart.vm.product');
  static bool get isProfile => const bool.fromEnvironment('dart.vm.profile');
  static bool get isDebug => (!dart.isRelease && !dart.isProfile);
  static bool get isAndroid => Platform.isAndroid;
  static bool get isFuchsia => Platform.isFuchsia;
  static bool get isIOS => Platform.isIOS;
  static bool get isLinux => Platform.isLinux;
  static bool get isMacOS => Platform.isMacOS;
  static bool get isWindows => Platform.isWindows;
  static bool get isIo => const bool.fromEnvironment('dart.library.io');
  static bool get isWeb => const bool.fromEnvironment('dart.library.js_util');

  static bool get isMobile => dart.isAndroid || dart.isIOS;
  static bool get isDesktop =>
      dart.isLinux || dart.isMacOS || dart.isWindows || dart.isFuchsia;

  static Map<String, String> get environment => Platform.environment;

  static String get executable => Platform.executable;

  static List<String> get executableArguments => Platform.executableArguments;

  static String get localHostname => Platform.localHostname;

  static String get localeName => Platform.localeName;

  static String get operatingSystem => Platform.operatingSystem;

  static String get operatingSystemVersion => Platform.operatingSystemVersion;

  static String? get packageConfig => Platform.packageConfig;

  static String get pathSeparator => Platform.pathSeparator;

  static String get resolvedExecutable => Platform.resolvedExecutable;

  static int get numberOfProcessors => Platform.numberOfProcessors;

  static String get version => Platform.version;
}
